add_choice_text("Typographical Clutter", { -- choice adventure number: 451
	["The left parenthesis"] = "Get left parenthesis",
	["The lower-case L"] = "Gain or lose meat",
	["The big apostrophe"] = "<b>Get plus sign</b>",
	["The lower-case E"] = "Gain 15 mysticality",
	["The upper-case Q"] = "<b>Gain Teleportitis</b>",
})


local potion_types = {
	"bubbly potion",
	"cloudy potion",
	"dark potion",
	"effervescent potion",
	"fizzy potion",
	"milky potion",
	"murky potion",
	"smoky potion",
	"swirly potion",
}

local potion_effects = {
	"acuity",
	"blessing",
	"booze",
	"confusion",
	"detection",
	"healing",
	"sleep",
	"strength",
	"teleportation",
}

local function get_potion_status()
--~ 	print("get potion status")
	local tbl = get_ascension_state("zone.dod.potions")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	unknown_potions = {}
	for _, pot in pairs(potion_types) do
		if not tbl[pot] then
			table.insert(unknown_potions, pot)
		end
	end

	found = {}
	for pot, eff in pairs(tbl) do
		found[eff] = pot
	end

	unknown_effects = {}
	for _, eff in pairs(potion_effects) do
		if not found[eff] then
			table.insert(unknown_effects, eff)
		end
	end

	if table.maxn(unknown_effects) == 1 and table.maxn(unknown_potions) == 1 then -- only one missing effect and one missing potion
		tbl[unknown_potions[1]] = unknown_effects[1]
		return tbl, {}
	else
--~ 		print("unknown effects", table.maxn(unknown_effects), table_to_str(unknown_effects))
--~ 		print("unknown potions", table.maxn(unknown_potions), table_to_str(unknown_potions))
		return tbl, unknown_potions
	end
end

add_processor("used combat item", function ()
	if item_image == "exclam.gif" then
		local tbl = get_ascension_state("zone.dod.potions")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		effects = {
			["acuity"] = "much smarter",
			["blessing"] = "much more stylish",
			["booze"] = "wino",
			["confusion"] = "confused",
			["detection"] = "blinks",
			["healing"] = "feels better",
			["sleep"] = "yawns",
			["strength"] = "much stronger",
			["teleportation"] = "disappearing",
		}
--~ 		print(item_name .. " | " .. text)
		for a, b in pairs(effects) do
			if string.find(text, b) then
				print(item_name .. " = " .. a)
				tbl[item_name] = a
			end
		end
		set_ascension_state("zone.dod.potions", table_to_str(tbl))
	end
end)

add_processor("/inv_use.php", function () -- unidentified/identified text does not get updated
	potion = string.match(text, "<table><tr><td><center><img src=\"http://images.kingdomofloathing.com/itemimages/exclam.gif\" width=30 height=30><br></center>.-You drink the ([a-z]- potion).")
	if potion then
		local tbl = get_ascension_state("zone.dod.potions")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		effects = {
			["booze"] = "liquid fire",
			["healing"] = "You gain [0-9]- [^D].-oints",
			["confusion"] = "Confused",
			["detection"] = "Object Detection",
			["sleep"] = "Sleepy",
			["strength"] = "Strength of Ten Ettins",
			["acuity"] = "Strange Mental Acuity",
			["blessing"] = "Izchak's Blessing",
			["teleportation"] = "Teleportitis",
		}
		for a, b in pairs(effects) do
			if string.match(text, b) then
				print(potion .. " = " .. a)
				tbl[potion] = a
			end
		end
		set_ascension_state("zone.dod.potions", table_to_str(tbl))
	end
end)

add_printer("/inventory.php", function ()
	local tbl = get_potion_status()
	for _, potion in pairs(potion_types) do
		if tbl[potion] then -- KoL javascript destroys <span> tags on inventory page
			value = [[<font style="color: green;">{]] .. tbl[potion] .. [[}</font>]]
		else
			value = [[<font style="color: darkorange;">{unidentified}</font>]]
		end

		text = string.gsub(text, [[(<b class="ircm">)(.-)(</b>&nbsp;<span>[^<]*</span>)]], function (pre, itemname, post)
			-- Support both inventory images turned on and off
			if string.find(itemname, potion) then
				return pre .. itemname .. post .. " " .. value
			else
				return false
			end
		end)
	end
end)

add_printer("/fight.php", function ()
	local tbl = get_potion_status()
	for _, potion in pairs(potion_types) do
		if tbl[potion] then
			value = "{" .. tbl[potion] .. "}"
		else
			value = "{unidentified}"
		end
		text = string.gsub(text, [[(<option picurl=exclam [^>]+>]] .. potion .. [[ %([0-9]+%))(</option>)]], "%1 " .. value .. "%2")
	end
end)

register_combat_skill("Identify potions", function(skills)
--~ 	print("registering id-potions skill")
	local _, unknown_potions = get_potion_status()
	to_id = {}
	for _, pot in pairs(unknown_potions) do
		if skills[pot] then
--~ 			print("potion", pot, tonumber(skills[pot].amount))
			if tonumber(skills[pot].amount) > 1 then
				table.insert(to_id, pot)
			end
		end
	end
--~ 	print("potion to_id", table_to_str(to_id))
	if to_id[1] then
		if to_id[2] and skills["Ambidextrous Funkslinging"] then
			return "Ambidextrous Funkslinging", { first = to_id[1], second = to_id[2] }
		else
			return to_id[1]
		end
	end
end)
